﻿MLC_CrabbyHasLoaded = true;
local CrabbyFont = "Interface\\AddOns\\MyLittleCompanion_Crabby\\Fonts\\comic.TTF"
CraTest = 0;



MLC_Crabby_TempDB = {
	["Category"] = "Idle",
	["SubID"]    = 1,
	["Timer"]    = 5,
}

function Crabby_Beep()
	PlaySoundFile("Interface\\AddOns\\MyLittleCompanion_Crabby\\Sounds\\MessageBeep.ogg", "Master")
end

function MLC_Crabby_OnLoad()
	MLC_Crabby_SetupVariables();
	MLC_SetupCrabbySays();
	MLC_Crabby_SetupBubble();
	MLC_Crabby_SetupEventTriggers();
	MLC_Crabby_InitialCheck();
end

function MLC_Crabby_InitialCheck()
	if MLC_DB["Pony"] == "Crabby" then
		MLC_Crabby_ChatReset();
	else
		MLC_Crabby_KillCrabbyChat();
	end
end

function MLC_Crabby_ChatReset()
	if MLC_Crabby_DB["FirstRun"] == 0 then
		local weekday, month, day, year = CalendarGetDate();
		
		if weekday == 6 then
			MLC_Crabby_QueUpNextCommand('Friday', 1, 0.5)
		else
			MLC_Crabby_QueUpNextCommand('Idle', nil, 0.5)
		end
	else
		MLC_Crabby_QueUpNextCommand('Initial', 1, 0.5)
	end
end	

function MLC_Crabby_KillCrabbyChat()
	CrabbySayTimer_Frame:Hide()
	MLC_Crabby_BubbleFrame:Hide()
end

function MLC_Crabby_SetupVariables()
	MLC_Crabby_DB = MLC_Crabby_DB or {};
	
	MLC_Crabby_DB["FirstRun"] = MLC_Crabby_DB["FirstRun"] or 1;
	
	MLC_Crabby_TempDB["LetCrabbySpeak"] = true;
end

local CrabbySayTimer = 0
CrabbySayTimer_Frame = CreateFrame("Frame");
CrabbySayTimer_Frame:Hide();
CrabbySayTimer_Frame:SetScript("OnUpdate", function(self,elapsed)
	CrabbySayTimer = CrabbySayTimer + elapsed;
	
	if CrabbySayTimer > MLC_Crabby_TempDB["Timer"] then
		if not InCombatLockdown() then
			CrabbySayTimer_Frame:Hide();
			
			local Category = MLC_Crabby_TempDB["Category"];
			local SubID    = MLC_Crabby_TempDB["SubID"];
			
			MLC_Crabby_SetBubbleText(Category, SubID)
		end
	end
end)

local TimerOffset = 1;

function MLC_Crabby_QueUpNextCommand(Category, SubID, Timer)
	CrabbySayTimer = 0;	-- Reset the timer count
	
	Timer    = Timer or 5;
	Category = Category or "Idle";
	
	
	if Timer == 5 then TimerOffset = TimerOffset + 1 end;
	
	Timer = Timer * 1 * TimerOffset;
	
	if TimerOffset >= 60 then TimerOffset = 60 end
	
	MLC_Crabby_TempDB["Timer"]    = Timer;
	MLC_Crabby_TempDB["Category"] = Category;
	MLC_Crabby_TempDB["SubID"]    = SubID;
	
	if MLC_Crabby_TempDB["LetCrabbySpeak"] then
		CrabbySayTimer_Frame:Show(); -- Start The Timer
	end
end

function MLC_Crabby_SetupBubble()
	--MLC_Crabby_BubbleFrame = 
	--MLC_AnimatedPonyBox
	
	local backdrop = {
	  bgFile = "Interface\\AddOns\\MyLittleCompanion\\Images\\Solid",  -- path to the background texture
	  edgeFile = "Interface\\AddOns\\MyLittleCompanion_Crabby\\Images\\Bubble",  -- path to the border texture
	  edgeSize = 20,  -- thickness of edge segments and square size of edge corners (in pixels)
	  insets = {    -- distance from the edges of the frame to those of the background texture (in pixels)
		left = 5,
		right = 5,
		top = 5,
		bottom = 5
	  }
	}
	
	MLC_Crabby_BubbleFrame = CreateFrame("Frame", "MLC_Crabby_BubbleFrame", MLC_AnimatedPonyBox)
	MLC_Crabby_BubbleFrame:SetPoint("Bottom", MLC_AnimatedPonyBox, "Top", 0,-50);
	MLC_Crabby_BubbleFrame:SetWidth(220); 
	MLC_Crabby_BubbleFrame:SetHeight(30);
	MLC_Crabby_BubbleFrame:SetBackdrop(backdrop);
	--MLC_Crabby_BubbleFrame:SetBackdropColor(0,1,0);
	--MLC_Crabby_BubbleFrame:SetBackdropBorderColor(1,0,0);
	
	MLC_Crabby_BubbleFrame:Hide();
	
	MLC_Crabby_BubbleSpeechBackground = MLC_Crabby_BubbleFrame:CreateTexture("MLC_Crabby_BubbleSpeechBackground")
	MLC_Crabby_BubbleSpeechBackground:SetPoint("TopLeft", MLC_Crabby_BubbleFrame, "Bottom", -80,3);
	MLC_Crabby_BubbleSpeechBackground:SetWidth(60); 
	MLC_Crabby_BubbleSpeechBackground:SetHeight(40);
	MLC_Crabby_BubbleSpeechBackground:SetTexture("Interface\\AddOns\\MyLittleCompanion_Crabby\\Images\\Bubble_Bottom")
	--MLC_Crabby_BubbleSpeechBackground:SetVertexColor(0,1,0);
	
	MLC_Crabby_BubbleText =  MLC_Crabby_BubbleFrame:CreateFontString("MLC_Crabby_BubbleText" ,"ARTWORK","GameFontNormal");
	MLC_Crabby_BubbleText:SetPoint("Top", -5, -15)
	--MLC_Crabby_BubbleText:SetWidth(MLC_Crabby_BubbleFrame:GetWidth()-20);
	MLC_Crabby_BubbleText:SetJustifyH("Left");
	MLC_Crabby_BubbleText:SetNonSpaceWrap(true);
	MLC_Crabby_BubbleText:SetTextColor(0,0,0);
	MLC_Crabby_BubbleText:SetFont(CrabbyFont, 15);
	
----CHOICES
	for i=1,4 do
		MLC_Crabby_Bullet_i = MLC_Crabby_BubbleFrame:CreateTexture("MLC_Crabby_Bullet_" .. i)
		if i == 1 then
			MLC_Crabby_Bullet_i:SetPoint("TopLeft", MLC_Crabby_BubbleText, "BottomLeft", 10,-30);
		else
			MLC_Crabby_Bullet_i:SetPoint("TopLeft", _G["MLC_Crabby_Bullet_" .. i-1], "TopLeft", 0,-45);
		end
		MLC_Crabby_Bullet_i:SetSize(12,12); 
		MLC_Crabby_Bullet_i:SetTexture("Interface\\AddOns\\MyLittleCompanion_Crabby\\Images\\Bullet")
		
		
		MLC_Crabby_BulletText_i =  MLC_Crabby_BubbleFrame:CreateFontString("MLC_Crabby_BulletText_" .. i ,"ARTWORK","GameFontNormal");
		MLC_Crabby_BulletText_i:SetPoint("Left", MLC_Crabby_Bullet_i, "Right", 10, 0);
		MLC_Crabby_BulletText_i:SetJustifyH("Left");
		MLC_Crabby_BulletText_i:SetText("Lipsum orem mortem")
		MLC_Crabby_BulletText_i:SetTextColor(0,0,1);
		MLC_Crabby_BulletText_i:SetFont(CrabbyFont, 15);
	
		MLC_Crabby_BulletText_i_Frame = CreateFrame("Frame","MLC_Crabby_BulletText_" .. i .. "_Frame",MLC_Crabby_BubbleFrame)
		--MLC_Crabby_BulletText_i_Frame:SetPoint("Center",MLC_Crabby_CloseButton,"Center")
		MLC_Crabby_BulletText_i_Frame:SetAllPoints(MLC_Crabby_BulletText_i)
		MLC_Crabby_BulletText_i_Frame:SetScript("OnEnter",   function(self) local _,_,_,ID = strsplit("_", self:GetName()); _G["MLC_Crabby_BulletText_" .. ID]:Hide() end);
		MLC_Crabby_BulletText_i_Frame:SetScript("OnLeave",   function(self) local _,_,_,ID = strsplit("_", self:GetName()); _G["MLC_Crabby_BulletText_" .. ID]:Show() end);
		MLC_Crabby_BulletText_i_Frame:SetScript("OnMouseUp", function(self) local _,_,_,ID = strsplit("_", self:GetName()); CrabbySelectOption(tonumber(ID)); end);
	end
-----------------
	
----CLOSE BUTTON
	MLC_Crabby_CloseButton =  MLC_Crabby_BubbleFrame:CreateFontString("MLC_Crabby_CloseButton" ,"ARTWORK","GameFontNormal");
	MLC_Crabby_CloseButton:SetPoint("TopRight", -5, -5);
	MLC_Crabby_CloseButton:SetJustifyH("Center");
	MLC_Crabby_CloseButton:SetText("X")
	MLC_Crabby_CloseButton:SetTextColor(0,0,1);
	
	MLC_Crabby_CloseButton_Frame = CreateFrame("Frame","MLC_Crabby_CloseButton_Frame",MLC_Crabby_BubbleFrame)
	--MLC_Crabby_CloseButton_Frame:SetPoint("Center",MLC_Crabby_CloseButton,"Center")
	MLC_Crabby_CloseButton_Frame:SetAllPoints(MLC_Crabby_CloseButton)
	MLC_Crabby_CloseButton_Frame:SetScript("OnEnter", function(self) MLC_Crabby_CloseButton:Hide() end);
	MLC_Crabby_CloseButton_Frame:SetScript("OnLeave", function(self) MLC_Crabby_CloseButton:Show() end);
	MLC_Crabby_CloseButton_Frame:SetScript("OnMouseUp", function(self) CrabbySelectOption("Close") end);
-----------------
end

function MLC_Crabby_SetBubblePoint(LeftOrRight)	-- "Left" or "Right"
	MLC_Crabby_BubbleSpeechBackground:ClearAllPoints();
	
	if LeftOrRight == "Left" then
		MLC_Crabby_BubbleSpeechBackground:SetPoint("TopLeft", MLC_Crabby_BubbleFrame, "BottomLeft", 10,7);
		MLC_Crabby_BubbleSpeechBackground:SetTexCoord(1, 0, 0, 1);
	else
		MLC_Crabby_BubbleSpeechBackground:SetPoint("TopRight", MLC_Crabby_BubbleFrame, "BottomRight", -10,7);
		MLC_Crabby_BubbleSpeechBackground:SetTexCoord(0, 1, 0, 1);
	end
end

function MLC_Crabby_SetBubbleText(Category, SubID)
	MLC_SetupCrabbySays(); -- Refresh the crabby says text
	
	CraTest = CraTest + 1;
	
	Category = Category or "Idle";	
	SubID = tonumber(SubID);
	if SubID == nil then
		SubID = random(#MLC_CrabbySays[Category]);
	end
	
	MLC_Crabby_TempDB["Category"] = Category or "Idle";
	MLC_Crabby_TempDB["SubID"]    = SubID;
	
	MLC_Crabby_BubbleText:SetText(MLC_CrabbySays[Category][SubID][1]);	
	
-- Hide the 4 options buttons
	for i=1,4 do
		_G["MLC_Crabby_Bullet_" .. i]:Hide();
		_G["MLC_Crabby_BulletText_" .. i]:Hide();
		
		_G["MLC_Crabby_BulletText_" .. i]:SetText("");
	end
	
	
	local k=4;
	for i=1,k do
		local ID = (i*2) + 1; -- Words stored at 3,5,7,9
		
		if MLC_CrabbySays[Category][SubID][ID] then
			_G["MLC_Crabby_Bullet_" .. i]:Show();
			_G["MLC_Crabby_BulletText_" .. i]:Show();
			
			local Text = MLC_CrabbySays[Category][SubID][ID];
			_G["MLC_Crabby_BulletText_" .. i]:SetText(Text);
		end
	end
	
	
-- calculate the extra height needed for the 4 otions buttons
	local ExtraHeight = 0;
	for i=1,4 do
		if _G["MLC_Crabby_Bullet_" .. i]:IsShown() then
			if i==1 then
				ExtraHeight = ExtraHeight + 15;
			end
			
			ExtraHeight = ExtraHeight + 45;
		end
	end
	
	local Width = MLC_Crabby_BubbleText:GetWidth() + 35
	
	if Width < 220 then
		Width = 220;
	end

	MLC_Crabby_BubbleFrame:SetHeight(MLC_Crabby_BubbleText:GetHeight() + 30 + ExtraHeight);
	MLC_Crabby_BubbleFrame:SetWidth(Width);
	
	Crabby_Beep();
	MLC_Crabby_BubbleFrame:Show();
end

function MLC_Crabby_HexToRGBPerc(hex)
	local rhex, ghex, bhex = string.sub(hex, 1, 2), string.sub(hex, 3, 4), string.sub(hex, 5, 6)
	return tonumber(rhex, 16)/255, tonumber(ghex, 16)/255, tonumber(bhex, 16)/255
end

function MLC_Crabby_CloseWindow()
	MLC_Crabby_BubbleFrame:Hide();
end

function CrabbySelectOption(Option)
	local Category = MLC_Crabby_TempDB["Category"];
	local SubID    = MLC_Crabby_TempDB["SubID"];
	local Script   = "";
	
	if Option == "Close" then
		Script = MLC_CrabbySays[ Category ][ SubID ][2];
		
		if IsAltKeyDown() then
			MLC_Crabby_TempDB["LetCrabbySpeak"] = false;
		end
	else
		local ScriptID = (Option*2) + 2;	-- script located at id's 4,6,8,10  [(1*2)+2=4, (2*2)+2=6,...]
		Script = MLC_CrabbySays[ Category ][ SubID ][ScriptID];
	end
	
	if Script == "" then
		Script = "MLC_Crabby_QueUpNextCommand('Idle', nil, 5)"
	end
	
	RunScript(Script);
	
	MLC_Crabby_CloseWindow();
end

function MLC_Crabby_SetupEventTriggers()
	local Crabby_Event = CreateFrame("Frame");
 
	--Crabby_Event:RegisterEvent("PLAYER_DEAD");
	
	Crabby_Event:SetScript("OnEvent", MLC_Crabby_Event_Function);
end

function MLC_Crabby_Event_Function(self, event, ...)
	local arg1, arg2, arg3, arg4, arg5, arg6 = ...;
	
	if event ~= nil then
		if event == "PLAYER_DEAD" then
		--	MLC_Crabby_QueUpNextCommand('Death', nil, 0);
		end
	end
end 