﻿--	In the format MLC_CrabbySays[ "<Message Type>" ] = "<MESSAGE>"
--	e.g.	MLC_CrabbySays["Idle"] = "Hello"

local Gender = nil;
local BoyGirl = nil;
local Class = nil;
local ExpansionList = {"The Burning Crusade", "Wrath of the Lich King", "Cataclysm"};

function MLC_SetupCrabbySays()
	local Level = UnitLevel("player");
	Gender = Gender or UnitSex("player"); --    1 = Neutrum / Unknown    2 = Male    3 = Female 
	Class = Class or UnitClass("player");
	local Zone = GetRealZoneText();
	
	Zone = Zone or "this place"
	
	if BoyGirl == nil then
		if Gender == 2 then
			BoyGirl = "boy"
		else
			BoyGirl = "girl"
		end
	end
	
	if Level == 84 then
		XLevelsToGo = "C'mon pal, 1 more level and you'll be a big " .. BoyGirl .. "!"
	elseif Level < 84 then
		XLevelsToGo = "C'mon pal, " .. 85 - Level ..  " more levels and you'll be a big " .. BoyGirl .. "!"
	else 
		XLevelsToGo = "Wow you are very powerful!"
	end
	
	local BestExpansion = ExpansionList[random(#ExpansionList)]
	
	MLC_CrabbySays	=	{
		["Initial"] = {
			[1] = {
				"Hi! I'm Crabby!",
				"MLC_Crabby_QueUpNextCommand('Initial', 2, 0.5)",
			},
			[2] = {
				"I want to make your dungeon experience as\ntrouble-free as possible!",
				"MLC_Crabby_QueUpNextCommand('Initial', 3, 0.5)",
			},
			[3] = {
				"You can post stuff that you think I should say on\nthe Curse site and it might get added!",
				"MLC_Crabby_QueUpNextCommand('Initial', 4, 0.5)",
			},
			[4] = {
				"I think we're going to be fast friends!\nI have a good feeling about you.",
				"MLC_Crabby_DB['FirstRun']=0; MLC_Crabby_QueUpNextCommand('Idle', nil, 5)",
			},
			
			
		},
		["Idle"] = {
			[1] = {
				"I think we're going to be fast friends!\nI have a good feeling about you.",	-- main text
				"",	-- script run on close
			},
			[2] = {
				"I want to make your dungeon experience as\ntrouble-free as possible!",
				"",
			},
			[3] = {
				"Would you like to play a game?",
				"",
				"What kind of game?",
				"MLC_Crabby_QueUpNextCommand('WhatGame?', nil, 0)",
				"Of course crabby!",
				"",
				"No, im kinda busy right now.",
				"",
			},
			[3] = {
				"My Little Companion.\nNow with 100% more crabby!",
				"",
				"Awesome!",
				"MLC_Crabby_QueUpNextCommand('Talk', 1, 0)",
			},
			
			
			[4] = {
				"Hey! Where are you going?\nMind if I tag along?",
				"",
				"Not at all!",
				"MLC_Crabby_QueUpNextCommand('Talk', 1, 0)",
			},
			[5] = {
				"That Deathwing sure is angry.",
				"",
			},
			[6] = {
				"You and I are the only people who exist.",
				"",
			},
			[7] = {
				"If I told you that you had a nice shell,\nwould you hold it against me?",
				"",
			},
			[8] = {
				"Do you read all of the patch notes updates?\nI try, but I get sleepy.",
				"",
			},
			[9] = {
				"Do you read all of the patch notes updates?\nI try, but I get sleepy.",
				"",
			},
			[10] = {
				"I was just minding my business in the high grass\nthe other day when some hooligan kid tried to\nshove me into a plastic ball, mumbling something\nabout needing to \"Catch 'em all.\"",
				"",
			},
			[11] = {
				"If someone sends you an inappropriate whisper in game,\nreport that player.",
				"",
			},
			[11] = {
				"I'm Commander Crabby, and " .. Zone .."\nis my new favorite place!\nWhat is yours?",
				"",
				"I like " .. Zone .. " too!",
				"MLC_Crabby_QueUpNextCommand('Talk', 1, 0)",
				"I love ALL the zones!",
				"MLC_Crabby_QueUpNextCommand('Talk', 2, 0)",
			},
			[12] = {
				"Blizzard Employees will never ask you\nfor your password.\n(They're really good at guessing)",
				"",	
			},
			[13] = {
				"Having one little claw and one big\nclaw means you're a boy crab!",
				"",	
			},
			[14] = {
				"If someone tries to convince you that it's\npossible for two people typing furiously\non the SAME keyboard to prevent a hacker\nfrom breaching your firewall, slap them with\nyour big claw!",
				"",	
			},
			[15] = {
				"My name's Crabby, are you my mother?",
				"",	
			},
			[16] = {
				"I'm selling these fine leather carapaces\n... Wait, what's the plural of carapace?\nCarapae? Carpaceses?",
				"",	
				"What?",
				"MLC_Crabby_QueUpNextCommand('Carapace', 4, 0)",
				"No one cares, Crabby.",
				"MLC_Crabby_QueUpNextCommand('Carapace', 3, 0)",
			},
			[17] = {
				"Do you like being a " .. Class .. "?",
				"",	
				"Yeah, its great!",
				"MLC_Crabby_QueUpNextCommand('Talk', 3, 0)",
			},
			[18] = {
				"Put items on your body to prevent swords\nfrom going through it!",
				"",	
				"Thanks Crabby",
				"MLC_Crabby_QueUpNextCommand('Talk', 4, 0)",
			},
			[19] = {
				XLevelsToGo,
				"",
			},
			[19] = {
				"It looks like you're going on an adventure!\nDon't take any arrows to the knee! ",
				"",
			},
			[20] = {
				"Huh. I just looted a Murloc, and he had no spine. How odd...",
				"",
				"I hate that",
				"MLC_Crabby_QueUpNextCommand('Murloc', 1, 0)",
				"Actually, it is quite easy to explain-",
				"MLC_Crabby_QueUpNextCommand('Murloc', 2, 0)",
			},   
			[21] = {
				"Would you like me to make you some waffles while you play?\nCarrots are good, too. HAHAHAHA",
				"",
			}, 
			[22] = {
				"Do people still play Saga of the\nPurple Drakonid? I love that game.",
				"",
				"I dunno",
				"MLC_Crabby_QueUpNextCommand('Love', 1, 0)",
				"Maybe",
				"MLC_Crabby_QueUpNextCommand('Love', 2, 0)",
				"What is love?",
				"MLC_Crabby_QueUpNextCommand('Love', 3, 0)",
			},
			[23] = {
				"What is your favourite expansion?\nMine was " .. BestExpansion,
				"",
				"I like that one too",
				"MLC_Crabby_QueUpNextCommand('Talk', 1, 0)",
				"I love them all",
				"MLC_Crabby_QueUpNextCommand('Talk', 2, 0)",
				"I liked classic",
				"MLC_Crabby_QueUpNextCommand('Talk', 5, 0)",
			},    
			[24] = {
				"There are no bad raiders, only\nbad network connections.",

			}, 
			
		},
		["Love"] = {
			[1] = {
				"Well they should. Write your local congressman.",
				"",
			},
			[2] = {
				"That's the spirit. Keep hope alive!",
				"",
			},
			[3] = {
				"Oh baby don't hurt me!",
				"",
				"Don't hurt me?",
				"MLC_Crabby_QueUpNextCommand('Love', 4, 0)",
			},
			[4] = {
				"No more",
				"",
			},
		},
		["Murloc"] = {
			[1] = {
				"I know! Totally immersion breaking.\nYou should post on the forums about it.",
				"",
			},
			[2] = {
				"Just killed another one... still no spine.\nAre they invertibrates?",
				"",
				"Did it have eyes?",
				"MLC_Crabby_QueUpNextCommand('Murloc', 3, 0)",
				"Careful, you'll pull them all",
				"MLC_Crabby_QueUpNextCommand('Murloc', 4, 0)",
			},
			[3] = {
				"Now that you mention it, I don't think it had any eyes.\nWhat sort of sick person designed this game?",
				"",
			},
			[4] = {
				"Uhoh... I'll be back in a few.",
				"",
			},
		
		},
		["Carapace"] = {
			[3] = {
				"No one covered in meat cares.",
				"",
			},
			[4] = {
				"Hey, can you do me a favor and look\nup the plural form of carapace on\nyour internets?",
				"",
				"Alright.",
				"MLC_Crabby_QueUpNextCommand('Carapace', 6, 0)",
				"Why don't you do it?",
				"MLC_Crabby_QueUpNextCommand('Carapace', 5, 0)",
			},			
			[5] = {
				"My network access is limited at work.\nI was spending too much time farming.",
				"",
			},			
			[6] = {
				"...Well?                                           ",
				"",
				"Ok, I didn't actually look it up",
				"MLC_Crabby_QueUpNextCommand('Carapace', 7, 0)",
				"It's ... ahhh ... carapacians",
				"MLC_Crabby_QueUpNextCommand('Carapace', 10, 0)",
			},			
			[7] = {
				"Oh, come on pal. I'm here busting my shell to serve up\nsweet pearls of bacon-flavored wisdom and you can't\nthrow me one little knowledge nugget?",
				"",
				"It's nothing personal, I'm allergic to wikipedia.",
				"MLC_Crabby_QueUpNextCommand('Carapace', 8, 0)",
				"Fine, fine, it's carapaces.",
				"MLC_Crabby_QueUpNextCommand('Carapace', 9, 0)",
			},			
			[8] = {
				"Oh, sorry; I can relate. I'm allergic to shellfish.",
				"",
			},			
			[9] = {
				"Oh, really? That's pretty straight-forward. Thanks, dude.",
				"",
			},			
			[10] = {
				"Waaaaaait.... Isn't that the guy who wrote those games\nabout punching dragons and being a space sherrif?",
				"",
				"I dunno. Maybe.",
				"MLC_Crabby_QueUpNextCommand('Carapace', 11, 0)",
				"No, you're thinking of Vigo the Carpathian.",
				"MLC_Crabby_QueUpNextCommand('Carapace', 12, 0)",
			},			
			[11] = {
				"He sounds like a cool crab.\nCrabby approves +5",
				"",				
			},		
			[12] = {
				"Is he a boss in Grim Batol?",
				"",	
				"He should be.",
				"MLC_Crabby_QueUpNextCommand('Carapace', 13, 0)",
			},
			[13] = {
				"He's sounds tough. I better read up on strats\nso I can better assist during that encounter.",
				"",	
			},			
		},		
		["Talk"] = {
			[1] = {
				"I KNEW we were going to be best pals!",
				"",
			},
			[2] = {
				"Me too!",
				"",
			},
			[3] = {
				"Maybe you can teach me to be a\n" .. Class .. " some day!",
				"",
			},
			[4] = {
				"Don't Mention it.",
				"",
			},
			[5] = {
				"I wasn't around back then.",
				"",
			},
			
		},
		["Friday"] = {
			[1] = {
				"Happy Friday! I woke up this morning\nwith this song stuck in my head...",
				"",
				"Oh Crabby, no!",
				"SendChatMessage('Crabby Yells: Its Friday, Friday.	 Gotta get down on Friday everybodys lookin forward to the weekend, weekend' ,'YELL'); MLC_Crabby_QueUpNextCommand('Friday', 2, 0)",
			},
			[2] = {
				"Oh Crabby, yes!",
				"",
			},
		},
		["WhatGame?"] = {
			[1] = {	--	1
				"I have a really cool quiz for you!",	-- main text
				"",	-- script run on close
				"Cool, I love quizzes!",
				"",
				"I dont like quizzes.",
				""
			},
			[2] = {	--	1
				"I was thinking of doing a jigsaw.",	-- main text
				"",	-- script run on close
				"A jigsaw?",
				"",
				"I dont like jigsaws.",
				""
			},
		},
		["Death"] = {
			[1] = {
				"Do you think there's an afterlife... for crabs.\nI do. I do",
				"",
			}
		},
		
	}
end

